#include "device_photoelectricswitch.h"
#include "device_interrupt.h"
#include "ptz_struct.h"
#include "l6235d.h"
#include "rotate_bldc.h"
#include "rotate_step.h"
#include "speed_to_bldc.h"
#include "gd32f4xx_it.h"
#include "ptz_type_select.h"
#include "get_angle.h"
/// @brief      ⲿжϳʼ 
/// @param[in]  usart_periph:EXTI_IRQ_init
/// @return     none 
/// @note       ޸־
///             LH2022-05-25
void EXTI_IRQ_init()
{
#ifdef L6235D
  /*HALLжϣˮƽPD13-H1,PD14-H2,PD15-H3ֱPC6-H1,PC7-H2,PC8-H3*/
  nvic_irq_enable(EXTI10_15_IRQn, 3U, 3U);//ˮƽһжϺж10-15
  nvic_irq_enable(EXTI5_9_IRQn, 3U, 2U);//ֱһжϺж5-9
  
  //Ӧⲿж
  syscfg_exti_line_config(EXTI_SOURCE_GPIOD, EXTI_SOURCE_PIN13);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOD, EXTI_SOURCE_PIN14);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOD, EXTI_SOURCE_PIN15);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOC, EXTI_SOURCE_PIN6);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOC, EXTI_SOURCE_PIN7);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOC, EXTI_SOURCE_PIN8);
  
  //ⲿж߳ʼ
  exti_init(EXTI_6, EXTI_INTERRUPT, EXTI_TRIG_RISING);//ж
  exti_init(EXTI_7, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_8, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_13, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_14, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_15, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  //־λ
  exti_interrupt_flag_clear(EXTI_6);
  exti_interrupt_flag_clear(EXTI_7);
  exti_interrupt_flag_clear(EXTI_8);
  exti_interrupt_flag_clear(EXTI_13);
  exti_interrupt_flag_clear(EXTI_14);
  exti_interrupt_flag_clear(EXTI_15);
  
  BSP_IntVectSet(39,EXTI5_9_IRQHandler);
  BSP_IntEn(39);
  
  BSP_IntVectSet(56,EXTI10_15_IRQHandler);
  BSP_IntEn(56);
#endif
  
#ifdef Full_bridge  //MOS+դ
  rcu_periph_clock_enable(RCU_SYSCFG);
  
    //ʱ
  rcu_periph_clock_enable(RCU_GPIOE);
  
  //ˮƽPE10-H1,PE11-H2,PE12-H3ֱPE13-H1,PE14-H2,PE15-H3
  //Ϊģʽ
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_10);
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_11);
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_12);
  
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_13);
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_14);
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_15);
  
  /*HALLжϣˮƽPE10-H1,PE11-H2,PE12-H3ֱPE13-H1,PE14-H2,PE15-H3*/
  //Ӧⲿж
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN10);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN11);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN12);
  
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN13);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN14);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN15);
  
  
  //ⲿж߳ʼ
  exti_init(EXTI_10, EXTI_INTERRUPT, EXTI_TRIG_RISING);//ж
  exti_init(EXTI_11, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_12, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  
  exti_init(EXTI_13, EXTI_INTERRUPT, EXTI_TRIG_RISING);//ж
  exti_init(EXTI_14, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  exti_init(EXTI_15, EXTI_INTERRUPT, EXTI_TRIG_RISING);
  
  exti_interrupt_enable(EXTI_10);
  exti_interrupt_enable(EXTI_11);
  exti_interrupt_enable(EXTI_12);
  
  exti_interrupt_enable(EXTI_13);
  exti_interrupt_enable(EXTI_14);
  exti_interrupt_enable(EXTI_15);
  
  
  //־λ
  exti_interrupt_flag_clear(EXTI_10);
  exti_interrupt_flag_clear(EXTI_11);
  exti_interrupt_flag_clear(EXTI_12);
  
  exti_interrupt_flag_clear(EXTI_13);
  exti_interrupt_flag_clear(EXTI_14);
  exti_interrupt_flag_clear(EXTI_15);
  
  nvic_irq_enable(EXTI10_15_IRQn, 2U, 2U);//һжϺж10-15
  
  BSP_IntVectSet(56,EXTI10_15_IRQHandler);
  BSP_IntEn(56);
  
  /*翪жPE7-SW1PE8-SW2PE9-SW3*/
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN7);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN8);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOE, EXTI_SOURCE_PIN9);
  
  //ֱ翪SW1
  #ifdef PTZ_SW1_DOWN_FALL_UPDATE
    exti_init(EXTI_7, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  #endif
    
  #ifdef PTZ_SW1_UP_RISE_UPDATE
    exti_init(EXTI_7, EXTI_INTERRUPT, EXTI_TRIG_BOTH);//ж
  #endif
  //ֱ翪SW2
    exti_init(EXTI_8, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  //ˮƽ翪SW3
  #ifdef PTZ_SW3_LEFT_RISE_UPDATE
    exti_init(EXTI_9, EXTI_INTERRUPT, EXTI_TRIG_BOTH);//ж
  #else
    exti_init(EXTI_9, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  #endif
  //־λ
  exti_interrupt_flag_clear(EXTI_7);
  exti_interrupt_flag_clear(EXTI_8);
  exti_interrupt_flag_clear(EXTI_9);

  nvic_irq_enable(EXTI5_9_IRQn, 2U, 3U);//翪
  
  BSP_IntVectSet(39,EXTI5_9_IRQHandler);
  BSP_IntEn(39);
  
#else
  /*翪жPB0-SW1PB1-SW2PB2-SW3*/
  nvic_irq_enable(EXTI0_IRQn, 2U, 0U);//ֱ翪SW1
  nvic_irq_enable(EXTI1_IRQn, 2U, 1U);//ֱ翪SW2
  nvic_irq_enable(EXTI2_IRQn, 2U, 2U);//ˮƽ翪SW3 
  
  syscfg_exti_line_config(EXTI_SOURCE_GPIOB, EXTI_SOURCE_PIN0);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOB, EXTI_SOURCE_PIN1);
  syscfg_exti_line_config(EXTI_SOURCE_GPIOB, EXTI_SOURCE_PIN2);
  
  //ֱ翪SW1
  #ifdef PTZ_SW1_DOWN_FALL_UPDATE
    exti_init(EXTI_0, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  #endif
    
  #ifdef PTZ_SW1_UP_RISE_UPDATE
    exti_init(EXTI_0, EXTI_INTERRUPT, EXTI_TRIG_BOTH);//ж
  #endif
  //ֱ翪SW2
    exti_init(EXTI_1, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  //ˮƽ翪SW3
  #ifdef PTZ_SW3_LEFT_RISE_UPDATE
    exti_init(EXTI_2, EXTI_INTERRUPT, EXTI_TRIG_BOTH);//ж
  #else
    exti_init(EXTI_2, EXTI_INTERRUPT, EXTI_TRIG_FALLING);//½ж
  #endif
  //־λ
  exti_interrupt_flag_clear(EXTI_0);
  exti_interrupt_flag_clear(EXTI_1);
  exti_interrupt_flag_clear(EXTI_2);
  
  BSP_IntVectSet(22,EXTI0_IRQHandler);
  BSP_IntEn(22);
  
  BSP_IntVectSet(23,EXTI1_IRQHandler);
  BSP_IntEn(23);
  
  BSP_IntVectSet(24,EXTI2_IRQHandler);
  BSP_IntEn(24);
#endif
}



/// @brief      翪жϴ 
/// @param[in]  sw_linex:EXTI_XⲿжߺEXTI_X
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void ptz_SW_IRQHandler(exti_line_enum sw_linex)
{
  
#ifdef PTZ_BLDC_MOTOR
#ifdef PTZ_NO_SELF_CHECK
  if(g_ptz.Voltage > SWITCH_IRQ_V)
  {
    switch(sw_linex)
    {   
        case EXTI_7://ֱ翪SW1
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW1_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw1_up_rise ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW1_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw1_down_fall ++;
            }
          }
  #endif
          
          break;
          
        case EXTI_8://ֱ翪SW2
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW2_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw2_up_fall ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW2_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw2_down_rise ++;
            }
          }
  #endif
          
  
          break;
          
        case EXTI_9://ˮƽ翪SW3
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(PS_HORI_SW3_READ == PS_LOW)
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_fall ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_fall ++;
            } 
          }
          if(PS_HORI_SW3_READ == PS_HIGH)
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_rise ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_rise ++;
//              term_printf(" hori_ps_sw3_left_rise \r\n");//жϲʹôڴӡռýϳʱ
            }
          }
  #endif
          
          break;
         
        default:break;
    }

  }
#else

  switch(sw_linex)
  {
      case EXTI_7://ֱ翪SW1
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW1_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw1_up_rise ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW1_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw1_down_fall ++;
            }
          }
  #endif
          
          break;
          
        case EXTI_8://ֱ翪SW2
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW2_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw2_up_fall ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW2_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw2_down_rise ++;
            }
          }
  #endif
          
  
          break;
          
        case EXTI_9://ˮƽ翪SW3
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(PS_HORI_SW3_READ == PS_LOW)
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_fall ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_fall ++;
            } 
          }
          if(PS_HORI_SW3_READ == PS_HIGH)
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_rise ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_rise ++;
//              term_printf(" hori_ps_sw3_left_rise \r\n");//жϲʹôڴӡռýϳʱ
            }
          }
  #endif
          
          break;
         
        default:break;
  }

#endif
#endif
  
#ifdef PTZ_STEP_MOTOR
#ifdef PTZ_NO_SELF_CHECK
  if(g_ptz.Voltage > SWITCH_IRQ_V)
  {
    switch(sw_linex)
    {   
        case EXTI_0://ֱ翪SW1
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW1_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw1_up_rise ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW1_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw1_down_fall ++;
            }
          }
  #endif
          
          break;
          
        case EXTI_1://ֱ翪SW2
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
          {
            if(PS_VERT_SW2_READ == PS_LOW)
            {
              g_ptz.vert_ps_sw2_up_fall ++;
            }
          }
          if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_DOWN)
          {
            if(PS_VERT_SW2_READ == PS_HIGH)
            {
              g_ptz.vert_ps_sw2_down_rise ++;
            }
          }
  #endif
          
  
          break;
          
        case EXTI_2://ˮƽ翪SW3
  #ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
          if(PS_HORI_SW3_READ == PS_LOW)
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_fall ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_fall ++;
            } 
          }
          else//PS_HIGH
          {
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
            {
              g_ptz.hori_ps_sw3_right_rise ++;
            }
            if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_LEFT)
            {
              g_ptz.hori_ps_sw3_left_rise ++;
            }
          }
  #endif
          
          break;
         
        default:break;
    }

  }
#else

  switch(sw_linex)
  {
      case EXTI_0://ֱ翪SW1
#ifdef PTZ_PHOTOELECTRIC_SWITCH

                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
        if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
        {
          if(PS_VERT_SW1_READ == PS_HIGH)
          {
            g_ptz.vert_ps_sw1_up_rise ++;
          }
        }
        else
        {
          if(PS_VERT_SW1_READ == PS_LOW)
          {
            g_ptz.vert_ps_sw1_down_fall ++;
          }
        }
#endif
        

        break;
        
      case EXTI_1://ֱ翪SW2
#ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
        if(g_ptz.vert_direction_actual == PTZ_VERT_DIR_UP)
        {
          if(PS_VERT_SW2_READ == PS_LOW)
          {
            g_ptz.vert_ps_sw2_up_fall ++;
          }
        }
        else
        {
          if(PS_VERT_SW2_READ == PS_HIGH)
          {
            g_ptz.vert_ps_sw2_down_rise ++;
          }
        }
#endif
        

        break;
        
      case EXTI_2://ˮƽ翪SW3
#ifdef PTZ_PHOTOELECTRIC_SWITCH
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
                 asm("nop");
        if(PS_HORI_SW3_READ == PS_LOW)
        {
          if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
          {
            g_ptz.hori_ps_sw3_right_fall ++;
          }
          else
          {
            g_ptz.hori_ps_sw3_left_fall ++;
          } 
        }
        else//PS_HIGH
        {
          if(g_ptz.hori_direction_actual == PTZ_HORI_DIR_RIGHT)
          {
            g_ptz.hori_ps_sw3_right_rise ++;
          }
          else
          {
            g_ptz.hori_ps_sw3_left_rise ++;
          }
        }
#endif
        

        break;
      
      default:break;
  }

#endif
#endif
  
}

/// @brief      ˮƽHALLжϴ 
/// @param[in]  hall_linex:EXTI_XⲿHALLжߺEXTI_X
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void ptz_H_HALL_IRQHandler(exti_line_enum hall_linex)
{
  
#ifdef PTZ_BLDC_MOTOR
#ifdef PTZ_HALL_FEEDBACK
  
  switch(hall_linex)
  { 
    case EXTI_10://ˮƽHALL-1
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_10) == SET)
//      {
      g_ptz.hori_l6235d.l6235d_hall_state_actual = L6235D_HALL_H1;//ǰ״̬
      //״̬
      //g_ptz.hori_l6235d.l6235d_hall_state_save[g_ptz.hori_l6235d.l6235d_satae_save_count] = L6235D_HALL_H1;
      //
//      g_ptz.hori_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.hori_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.hori_l6235d.l6235d_satae_save_count = 0;
//      }
      //H1
      g_ptz.hori_l6235d.l6235d_hall_h1_count++;
      
#ifdef PTZ_PID_HALL_SPEED
      g_ptz.hori_pid.hall_h1_count ++;
#endif
//      g_ptz.hori_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.hori_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.hori_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.hori_l6235d.l6235d_hall_state_actual != 0 && g_ptz.hori_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H1 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H2)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_RIGHT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H1 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H3)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_LEFT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.hori_l6235d.l6235d_hall_state_last = g_ptz.hori_l6235d.l6235d_hall_state_actual;
      
                  //
#ifdef PTZ_ELECTRIC_STABLE_ON
      if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
      {
        g_ptz.hori_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.hori_electric_stable.stop_hall_count = 0;
      }
#endif
//      }
      break;

    case EXTI_11://ˮƽHALL-2
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_11) == SET)
//      {
      g_ptz.hori_l6235d.l6235d_hall_state_actual = L6235D_HALL_H2;//ǰ״̬
      //״̬
      //g_ptz.hori_l6235d.l6235d_hall_state_save[g_ptz.hori_l6235d.l6235d_satae_save_count] = L6235D_HALL_H2;
      //
//      g_ptz.hori_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.hori_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.hori_l6235d.l6235d_satae_save_count = 0;
//      }
      //H2
      g_ptz.hori_l6235d.l6235d_hall_h2_count++;
      
#ifdef PTZ_PID_HALL_SPEED
      g_ptz.hori_pid.hall_h2_count ++;
#endif      
//      g_ptz.hori_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.hori_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.hori_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.hori_l6235d.l6235d_hall_state_actual != 0 && g_ptz.hori_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H2 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H3)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_RIGHT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H2 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H1)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_LEFT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.hori_l6235d.l6235d_hall_state_last = g_ptz.hori_l6235d.l6235d_hall_state_actual;
      
                        //
#ifdef PTZ_ELECTRIC_STABLE_ON
      if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
      {
        g_ptz.hori_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.hori_electric_stable.stop_hall_count = 0;
      }
#endif
//      }
      break;

    case EXTI_12://ˮƽHALL-3
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_12) == SET)
//      {
      g_ptz.hori_l6235d.l6235d_hall_state_actual = L6235D_HALL_H3;//ǰ״̬
      //״̬
      //g_ptz.hori_l6235d.l6235d_hall_state_save[g_ptz.hori_l6235d.l6235d_satae_save_count] = L6235D_HALL_H3;
      //
//      g_ptz.hori_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.hori_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.hori_l6235d.l6235d_satae_save_count = 0;
//      }
      //H3
      g_ptz.hori_l6235d.l6235d_hall_h3_count++;

#ifdef PTZ_PID_HALL_SPEED
      g_ptz.hori_pid.hall_h3_count ++;
#endif      
//      g_ptz.hori_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.hori_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.hori_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.hori_l6235d.l6235d_hall_state_actual != 0 && g_ptz.hori_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H3 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H1)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_RIGHT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.hori_l6235d.l6235d_hall_state_actual == L6235D_HALL_H3 && 
          g_ptz.hori_l6235d.l6235d_hall_state_last == L6235D_HALL_H2)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
          {
            g_ptz.hori_direction_actual = PTZ_HORI_DIR_LEFT;
          }
#endif
          g_ptz.hori_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.hori_l6235d.l6235d_hall_state_last = g_ptz.hori_l6235d.l6235d_hall_state_actual;
                        //
#ifdef PTZ_ELECTRIC_STABLE_ON
      if(g_ptz.hori_start_stop_set == PTZ_HORI_STOP)
      {
        g_ptz.hori_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.hori_electric_stable.stop_hall_count = 0;
      }
#endif
//      }
      break;

    default:break;
  }


#endif

#endif

}



/// @brief      ֱHALLжϴ 
/// @param[in]  hall_linex:EXTI_XⲿHALLжߺEXTI_X
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void ptz_V_HALL_IRQHandler(exti_line_enum hall_linex)
{
  
#ifdef PTZ_BLDC_MOTOR
#ifdef PTZ_HALL_FEEDBACK
  
  switch(hall_linex)
  { 
    
    case EXTI_13://ֱHALL-1
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_13) == SET)
//      {
      g_ptz.vert_l6235d.l6235d_hall_state_actual = L6235D_HALL_H1;//ǰ״̬
      //״̬
      //g_ptz.vert_l6235d.l6235d_hall_state_save[g_ptz.vert_l6235d.l6235d_satae_save_count] = L6235D_HALL_H1;
      //
//      g_ptz.vert_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.vert_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.vert_l6235d.l6235d_satae_save_count = 0;
//      }
      //H1
      g_ptz.vert_l6235d.l6235d_hall_h1_count++;

#ifdef PTZ_PID_HALL_SPEED
      g_ptz.vert_pid.hall_h1_count ++;
#endif      
//      g_ptz.vert_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.vert_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.vert_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.vert_l6235d.l6235d_hall_state_actual != 0 && g_ptz.vert_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H1 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H2)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_UP;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H1 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H3)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_DOWN;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.vert_l6235d.l6235d_hall_state_last = g_ptz.vert_l6235d.l6235d_hall_state_actual;
      
      //
#ifdef PTZ_ELECTRIC_STABLE_ON
      if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
      {
        g_ptz.vert_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.vert_electric_stable.stop_hall_count = 0;
      }
#endif
//      }
      break;

    case EXTI_14://ֱHALL-2
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_14) == SET)
//      {
      g_ptz.vert_l6235d.l6235d_hall_state_actual = L6235D_HALL_H2;//ǰ״̬
      //״̬
      //g_ptz.vert_l6235d.l6235d_hall_state_save[g_ptz.vert_l6235d.l6235d_satae_save_count] = L6235D_HALL_H2;
      //
//      g_ptz.vert_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.vert_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.vert_l6235d.l6235d_satae_save_count = 0;
//      }
      //H2
      g_ptz.vert_l6235d.l6235d_hall_h2_count++;

#ifdef PTZ_PID_HALL_SPEED
      g_ptz.vert_pid.hall_h2_count ++;
#endif  
//      g_ptz.vert_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.vert_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.vert_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.vert_l6235d.l6235d_hall_state_actual != 0 && g_ptz.vert_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H2 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H3)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_UP;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H2 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H1)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_DOWN;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.vert_l6235d.l6235d_hall_state_last = g_ptz.vert_l6235d.l6235d_hall_state_actual;

      //
#ifdef PTZ_ELECTRIC_STABLE_ON      
      if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
      {
        g_ptz.vert_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.vert_electric_stable.stop_hall_count = 0;
      }
#endif
//      }
      break;

    case EXTI_15://ֱHALL-3
//      if(gpio_input_bit_get(GPIOE, GPIO_PIN_15) == SET)
//      {
      g_ptz.vert_l6235d.l6235d_hall_state_actual = L6235D_HALL_H3;//ǰ״̬
      //״̬
      //g_ptz.vert_l6235d.l6235d_hall_state_save[g_ptz.vert_l6235d.l6235d_satae_save_count] = L6235D_HALL_H3;
      //
//      g_ptz.vert_l6235d.l6235d_satae_save_count ++;
//      if(g_ptz.vert_l6235d.l6235d_satae_save_count >= L6235D_HALL_SAVE_NUM)
//      {
//        g_ptz.vert_l6235d.l6235d_satae_save_count = 0;
//      }
      //H3
      g_ptz.vert_l6235d.l6235d_hall_h3_count++;

#ifdef PTZ_PID_HALL_SPEED
      g_ptz.vert_pid.hall_h3_count ++;
#endif
//      g_ptz.vert_l6235d.l6235d_hall_h123_count++;//
//      if(g_ptz.vert_l6235d.l6235d_hall_h123_count >= UNSIGNED_INT_MAX_VALUE)
//      {
//        g_ptz.vert_l6235d.l6235d_hall_h123_count = 0;
//      }
      //жϵʵת,̨ʵʵת
      if(g_ptz.vert_l6235d.l6235d_hall_state_actual != 0 && g_ptz.vert_l6235d.l6235d_hall_state_last != 0)
      {
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H3 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H1)//жϷ
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_UP;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_FWD;
        }
        if(g_ptz.vert_l6235d.l6235d_hall_state_actual == L6235D_HALL_H3 && 
          g_ptz.vert_l6235d.l6235d_hall_state_last == L6235D_HALL_H2)
        {
#ifdef PTZ_HALL_DIR
          if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
          {
            g_ptz.vert_direction_actual = PTZ_VERT_DIR_DOWN;
          }
#endif
          g_ptz.vert_l6235d.l6235d_motor_dir_actual = L6235D_MOTOR_DIR_REV;
        }
      }
      g_ptz.vert_l6235d.l6235d_hall_state_last = g_ptz.vert_l6235d.l6235d_hall_state_actual;

      //
#ifdef PTZ_ELECTRIC_STABLE_ON      
      if(g_ptz.vert_start_stop_set == PTZ_VERT_STOP)
      {
        g_ptz.vert_electric_stable.stop_hall_count ++;
      }
      else
      {
        g_ptz.vert_electric_stable.stop_hall_count = 0;
      }
      
#endif     
//      }
      break;
   
    default:break;
  }


#endif

#endif

}






















